﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using Infragistics.UltraChart.Core.Layers;
using Infragistics.UltraChart.Core.Primitives;
using System.Collections;
using Infragistics.UltraChart.Resources;

public partial class _Default : System.Web.UI.Page 
{
    protected void Page_Load(object sender, EventArgs e)
    {
        this.UltraChart1.Data.DataSource = Infragistics.UltraChart.Data.DemoTable.Table();
        this.UltraChart1.Data.DataBind();
        this.UltraChart1.FillSceneGraph += new Infragistics.UltraChart.Shared.Events.FillSceneGraphEventHandler(UltraChart1_FillSceneGraph);
        this.UltraChart1.ChartType = Infragistics.UltraChart.Shared.Styles.ChartType.LineChart;
        Hashtable labelRenderers = new Hashtable();
        labelRenderers.Add("MY_LABEL", new MyLabelRenderer());
        this.UltraChart1.LabelHash = labelRenderers;
        this.UltraChart1.Tooltips.FormatString = "<MY_LABEL>";
    }
    internal class MyLabelRenderer : IRenderLabel
    {
        public string ToString(Hashtable context)
        {
            int row = Convert.ToInt32(context["DATA_ROW"]);
            if (row > 999)
            {
                return context["MY_VALUE"].ToString();
            }
            else
            {
                return context["DATA_VALUE"].ToString();
            }
        }

    }
    void UltraChart1_FillSceneGraph(object sender, Infragistics.UltraChart.Shared.Events.FillSceneGraphEventArgs e)
    {
        Axis yAxis = e.Grid["Y"] as Axis;
        Axis xAxis = e.Grid["X"] as Axis;
        if (yAxis == null)
        {
            return;
        }
        PrimitiveCollection primitivesToAdd = new PrimitiveCollection();
        int pointCounter = 0;
        foreach (Primitive p in e.SceneGraph)
        {
            Line l = p as Line;
            if (l != null && l.p1.Y == l.p2.Y)
            {
                // this should be the x axis line
                l.p1.X = yAxis.startPoint.X;
                l.p2.X = e.ChartCore.GetChartLayer().GetOuterBounds().Right;
            }
            Text t = p as Text;
            if (t != null && (t.bounds.Right < yAxis.startPoint.X || t.bounds.Top > xAxis.startPoint.Y || (t.Path != null && (t.Path == "Border.Title.Grid.X" || t.Path == "Border.Title.Grid.Y"))))
            {
                Box boxToAdd = new Box(t.bounds);
                boxToAdd.PE.FillOpacity = boxToAdd.PE.StrokeOpacity = 0;
                boxToAdd.Caps = PCaps.Tooltip | PCaps.HitTest;
                boxToAdd.Layer = e.ChartCore.GetChartLayer();
                boxToAdd.Chart = e.ChartCore.ChartType;
                boxToAdd.Row = boxToAdd.Column = 1000 + pointCounter++;
                double k;
                if (double.TryParse(t.GetTextString(), out k) == true)
                {
                    boxToAdd.Value = double.Parse(t.GetTextString());
                }
                else
                {
                    boxToAdd.Value = t.GetTextString();
                }
                boxToAdd.Tags = new Hashtable();
                boxToAdd.Tags.Add("MY_VALUE", boxToAdd.Value);
                primitivesToAdd.Add(boxToAdd);
            }
        }
        e.SceneGraph.AddRange(primitivesToAdd.ToArray());
    }
}
